from glob import glob
import os
from NuRadioMC.utilities import Veff
import sys

step3dir = sys.argv[1]
step4dir = sys.argv[2]

step3_dirs = glob(f"{step3dir}/**/", recursive = True)
print(f"found {len(step3_dirs)} step3 dirs in {step3dir}")

for directory in step3_dirs:
    h5files = glob(f'{directory}/*.hdf5')
    if not h5files:
        print("no hdf5 files in path, continuing")
        continue
    else:
        print(directory)

        for h5file in h5files:
            identifier = directory.replace(step3dir,"")
            identifier = "__".join([x for x in identifier.split("/") if x != ""])
            output_jsonfile = f"Veff_allsky__{identifier}.json"

            if not os.path.exists(step4dir):
                os.makedirs(step4dir)

            print(f"- OUTDIR: {step4dir}")
            print(f"- OUTFILE: {output_jsonfile}")

            if os.path.exists(os.path.join(step4dir, output_jsonfile)):
                print(f"Veff json file already exists")
                continue

        
            v = Veff.get_Veff_Aeff(h5file)
            Veff.export(os.path.join(step4dir, output_jsonfile), v, export_format="json")

            output_jsonfile_fine = f"Veff_fine_20__{identifier}.json"
            v_fine = Veff.get_Veff_Aeff(h5file, oversampling_theta=20)
            Veff.export(os.path.join(step4dir, output_jsonfile_fine), v_fine, export_format="json")

            output_jsonfile_fine = f"Veff_fine_21__{identifier}.json"
            v_fine = Veff.get_Veff_Aeff(h5file, oversampling_theta=21)
            Veff.export(os.path.join(step4dir, output_jsonfile_fine), v_fine, export_format="json")
